#ifndef __PTZ_PARSER_DEFINE_H__
#define __PTZ_PARSER_DEFINE_H__



enum PTZ_COMMAND
{
	PTZ_COMMAND_INIT = 1,
	PTZ_MOVE_LEFT, 
	PTZ_MOVE_RIGHT, 
	PTZ_MOVE_UP, 
	PTZ_MOVE_DOWN, 
	PTZ_MOVE_STOP, 
	PTZ_MOVE_HOME, 
	PTZ_OSD_ON, 
	PTZ_OSD_OFF, 
	PTZ_OSD_UP, 
	PTZ_OSD_DOWN, 
	PTZ_OSD_LEFT, 
	PTZ_OSD_RIGHT, 
	PTZ_OSD_LEAVE, 
	PTZ_OSD_STOP, 
	PTZ_OSD_ENTER,
	PTZ_FOCUS_IN, 
	PTZ_FOCUS_OUT, 
	PTZ_FOCUS_STOP,
	PTZ_IRIS_OPEN, 
	PTZ_IRIS_CLOSE, 
	PTZ_IRIS_STOP, 
	PTZ_IRIS_AUTO,
	PTZ_PRESET_SET, 
	PTZ_PRESET_GOTO, 
	PTZ_PRESET_CLEAR, 
	PTZ_PRSSET_TOUR,
	PTZ_ZOOM_IN,
	PTZ_ZOOM_OUT,
	PTZ_ZOOM_STOP,
	PTZ_BLC_ON,
	PTZ_BLC_OFF,
	PTZ_DAYNIGHT_ON,
	PTZ_DAYNIGHT_OFF,
	PTZ_DAYNIGHT_AUTO_ON,
	PTZ_DAYNIGHT_AUTO_OFF,
	PTZ_MOVE_UPLEFT,
	PTZ_MOVE_UPRIGHT,
	PTZ_MOVE_DOWNLEFT,
	PTZ_MOVE_DOWNRIGHT, 
	PTZ_COMMAND_MAX
};

enum PTZ_VENDER_PROTOCOL
{
	PTZ_VENDER_PROTOCOL_INIT = 1,
	DYNACOLOR_DYNACOLOR,
	DYNACOLOR_PELCOD,
	DYNACOLOR_PELCOP,
	EYEVIEW_EYEVIEWV1,
	EYEVIEW_EYEVIEWV2,
	EYEVIEW_PELCOD,
	EYEVIEW_PELCOP,
	GE_KALATEL, 
	HARRISONTECH_VICSA,
	KAMPRO_KAMPRO,
	KAMPRO_V2,
	LILIN_LILIN, 
	MESSOA_PELCOD,
	MESSOA_PELCOP,
	MESSOA_VCL,
	NICECAM_NICECAM,
	PANASONIC_PANASONIC,
	PELCO_PELCOD,
	PELCO_PELCOP, 
	PELCO_PELCOPV1, 
	PELCO_PELCOPV2,
	PIXIM_PIXIM,
	SAMSUNG_SAMSUNG,
	TOA_TOA, 
	VICON_VICON,
	VIDEOTREC_VIDEOTREC, 
	VCL_VCL,
	PTZ_VENDER_PROTOCOL_MAX
};

// _V for Vender
enum PTZ_VENDER
{
	PTZ_VENDER_INIT = 1,
	DYNACOLOR_V,			// Vender
	EYEVIEW_V,
	GE_V, 
	HARRISONTECH_V,
	KAMPRO_V,
	LILIN_V, 
	MESSOA_V,
	NICECAM_V,
	PANASONIC_V,
	PELCO_V,
	PIXIM_V,
	SAMSUNG_V,
	TOA_V, 
	VICON_V,
	VIDEOTREC_V, 
	VCL_V,
	PTZ_VENDER_MAX
};

// _P for Protocol
enum PTZ_PROTOCOL
{
	PTZ_PROTOCOL_INIT = 1,
	KAMPRO_P,
	PELCOD_P,
	PELCOP_P,
	VCL_P,
	EYEVIEWV1_P,
	EYEVIEWV2_P,
	DYNACOLOR_P,
	KALATEL_P, 
	VICSA_P,
	V2_P,
	LILIN_P, 
	NICECAM_P,
	PANASONIC_P,
	PELCOPV1_P, 
	PELCOPV2_P,
	PIXIM_P,
	SAMSUNG_P,
	TOA_P, 
	VICON_P,
	VIDEOTREC_P, 
	PTZ_PROTOCOL_MAX
};

#endif // __PTZ_PARSER_DEFINE_H__